#include "testlib.h"
#include <iostream>
#include <numeric>

using namespace std;


int get_finish(const vector <int>& a, int t, int start) {
    int ans = 0, fin = start;
    int dist = 0;
    for (int end = start; end >= 0; end--) {
        int now = (t - dist) / a[end] + (start - end);
        if (now > ans) {
            ans = now;
            fin = end;
        }
        dist += a[end];
        if (dist >= t) {
            break;
        }
    }
    dist = 0;
    for (int end = start; end < a.size(); end++) {
        int now = (t - dist) / a[end] + (end - start);
        if (now > ans) {
            ans = now;
            fin = end;
        }
        dist += a[end];
        if (dist >= t) {
            break;
        }
    }
    return fin;
}


// something like    5 5 5 5 2 2 2 5 5 5 5 5 5 5 1 1 1 1 5 5 5 5 and need to go to 2
//                          -good-                  -bad-
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>(1);
    int center = opt<int>(2);
    int mx = 1'000'000'000;
    if (argc > 3) {
        mx = opt<int>(3);
    }
    
    while (true) {
        int good_left = rnd.next(n / 3, n * 2 / 3);
        int good_right = good_left + rnd.next(1, n / 10);
        int bad_left1 = rnd.next(0, n / 3);
        int bad_right1 = bad_left1 + rnd.next(1, n / 10);
        int bad_left2 = rnd.next(2 * n / 3, n - n / 10);
        int bad_right2 = bad_left2 + rnd.next(1, n / 10);

        vector <int> ans(n);
        for (int& i : ans) {
            i = rnd.next(center * 2, center * 4);
        }
        for (int i = good_left; i < good_right; i++) {
            ans[i] = rnd.next(center, center * 2);
        }
        for (int i = bad_left1; i < bad_right1; i++) {
            ans[i] = rnd.next(center / 2, center);
        }
        for (int i = bad_left2; i < bad_right2; i++) {
            ans[i] = rnd.next(center / 2, center);
        }

        vector <int> opts;
        for (int i = (bad_right1 + good_left) / 2; i < (good_right + bad_left2) / 2; i++) {
            opts.push_back(i);
        }
        iota(opts.begin(), opts.end(), 0);
        shuffle(opts.begin(), opts.end());
        if (n > 10'000) {
            opts.erase(opts.begin() + 10'000, opts.end());
        }

        int t = rnd.next(mx / 10, mx);
        vector <int> starts;
        for (int i : opts) {
            int fin = get_finish(ans, t, i);
            if (!(bad_left1 <= fin && fin <= bad_right1) && !(bad_left2 <= fin && fin <= bad_right2)) {
                starts.push_back(i + 1);
            }
        }
        if (!starts.empty()) {
            println(n, starts.size(), t);
            println(ans);
            sort(starts.begin(), starts.end());
            println(starts);
            break;
        }
    }
}
